'use strict';

let Mongo = require('bem-mongo');
let Phone = require('./phone');
let Email = require('./email');

let cache = {};

class Register {

  static * get(config) {
    config.className = config.className || '_User';
    config.type = config.type || 'phone';
    let key = `${config.db}/${config.type}`;
    let inst = cache[key];
    if (!inst) {
      let mongo = yield Mongo.get({
        db: config.db
      });
      config.mongo = mongo;
      if (config.type === 'phone') {
        inst = new Phone(config);
      } else if (config.type === 'email') {
        inst = new Email(config);
      }
      cache[key] = inst;
    }
    return inst;
  }

}

module.exports = Register;
